%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Task_Convert_Fasteners(Fastener_Convertion, RutFast_Axial_Constraint)

global ErrCode;

global DB_FASTENERS;

if (size(DB_FASTENERS,1) == 0)
    fprintf (1, 'Пустая база данных крепежа!\n');
    ErrCode = -1;
    return;
end

% Инициализация счетчиков

Bar_To_Rutman_Convert_Counter = 0;
Rutman_To_Bar_Convert_Counter = 0;

fprintf (1, '    Ход выполнения:\n');

% --- Конвертация болтов ---

switch Fastener_Convertion
    
    case 'ALL_BAR_TO_RUTMAN'
        
        fprintf (1, '        Конвертация балочных болтов в болты Рутмана... ');
        
        % Цикл по всем болтам
        for i=1:size(DB_FASTENERS,1)
            
            % Если болт балочный
            if (strcmp(DB_FASTENERS{i}.topology, 'bar_fastener'))
                
                % Конвертация балочного болта в болт Рутмана
                Convert_Bar_To_Rutman(i, RutFast_Axial_Constraint);
            
                if (ErrCode < 0)
                    return;
                end
                
                % Обновление счетчиков
                Bar_To_Rutman_Convert_Counter = Bar_To_Rutman_Convert_Counter + 1;
            
            end
            
        end
        
        fprintf (1, 'OK!\n');
        
    case 'ALL_RUTMAN_TO_BAR'
        
        fprintf (1, '        Конвертация болтов Рутмана в балочные болты... ');
        
        % Цикл по всем болтам
        for i=1:size(DB_FASTENERS,1)
            
            % Если болт Рутмана
            if (strcmp(DB_FASTENERS{i}.topology, 'rutman_fastener'))
                
                % Конвертация болта Рутмана в балочный болт
                Convert_Rutman_To_Bar(i);
            
                if (ErrCode < 0)
                    return;
                end
                
                % Обновление счетчиков
                Rutman_To_Bar_Convert_Counter = Rutman_To_Bar_Convert_Counter + 1;
            
            end
            
        end
        
        fprintf (1, 'OK!\n');
        
    otherwise
        fprintf (1, 'Недопустимое значение параметра Fastener_Convertion !\n');
        ErrCode = -1;
        return;
        
end

% --- Вывод статистики ---

fprintf (1, '\n    Статистика:\n');

% Счетчики конвертации крепежа
if (strcmp(Fastener_Convertion, 'ALL_BAR_TO_RUTMAN'))
    fprintf (1, '        Конвертировано балочных болтов в болты Рутмана: %i\n', Bar_To_Rutman_Convert_Counter);
end

if (strcmp(Fastener_Convertion, 'ALL_RUTMAN_TO_BAR'))
    fprintf (1, '        Конвертировано болтов Рутмана в балочные болты: %i\n', Rutman_To_Bar_Convert_Counter);
end
